var React = require('react');

var ReactMaskedInput = React.createClass({
    getDefaultProps: function() {
        return {
            mask: 'NNN-NNN-NNNN',
            numberPlaceholder: '#',
            type: 'number',
            value: ''
        }
    },

    componentDidUpdate: function() {
        if (document.activeElement == this.getDOMNode()) {
            this.setSelection();
        }
    },

    render: function() {
        return React.createElement('input', {
            required: this.props.required,
            readOnly: this.props.readOnly,
            className: this.props.className,
            onChange: this.onChange,
            onFocus: this.handleFocus,
            onBlur: this.props.onBlur,
            onKeyDown: this.handleKeyDown,
            onClick: this.handleFocus,
            value: this.mask(this.props.value || ''),
            type: this.props.type
        });
    },

    handleKeyDown: function(e) {
        if (e.keyCode == 8) {
            e.preventDefault();
            var selectionStart = this.getDOMNode().selectionStart;
            var selectionEnd = this.getDOMNode().selectionEnd;

            if (selectionStart != selectionEnd) {
                this.handleFocus();
                e.preventDefault();
                return;
            }

            var value = this.unmask(this.props.value).split('');

            value.pop();
            value = value.join('');

            this.props.onChange(value);
        }
    },

    onChange: function(e) {
        this.props.onChange(
            this.mask(e.target.value),
            this.setSelection
        );

        this.handleFocus(e);
    },

    setSelection: function() {
        var numberIndex = this.mask(this.props.value).indexOf(
            this.props.numberPlaceholder
        );

        if (numberIndex == -1) {
            numberIndex = this.mask(this.props.value).length;
        }

        this.getDOMNode().setSelectionRange(
            numberIndex,
            numberIndex
        );
    },

    handleFocus: function(e) {
        this.setSelection();

        if (this.props.onFocus) {
            this.props.onFocus(e);
        }
    },

    mask: function(inputString) {
        // shift characters of this.props.mask while constructing
        // a masked value
        var newBuffer = [];
        var mask = this.props.mask.split('');
        var input = this.unmask(inputString).split('');

        var stringIndex = 0;
        var currentChar = '';

        while (currentChar = mask.shift()) {
            if (currentChar == 'N') {
                newBuffer.push(
                    input.shift() ||
                        this.props.numberPlaceholder
                );
            } else {
                newBuffer.push(currentChar);
            }
        }

        return newBuffer.join('');
    },

    unmask: function(string) {
        if (!string) { string = ''; }

        // replace none numbers (globally) with ''
        return string.replace(/\D/g, '');
    }
});

module.exports = ReactMaskedInput;

